﻿Imports Microsoft.VisualBasic.FileIO
Imports System.IO

Public Class Form1

    Dim RetVarDouble(,) As Double = Nothing
    Dim RetNumRows As Integer
    Dim RetNumCols As Integer
    Dim LocExe As String = "C:\Software\ExpressionEvaluator\Evaluate\distrib\"
    Dim LocScript As String = "C:\Software\ExpressionEvaluator\Scripts\"
    Dim LocOutput As String = "C:\Software\ExpressionEvaluator\Output\"

    Private Sub ButtonRun_Click(sender As Object, e As EventArgs) Handles ButtonRun.Click

        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn1.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

        'Read data into variable
        Dim OutFilename As String = "MyY.dat"
        Dim delimiter As String = ","

        Read2DArrayFromFile(LocOutput & OutFilename, delimiter)
        Dim VariableDimensions As String = CStr(RetNumRows) & " x " & CStr(RetNumCols)
        TextBoxDimensions.Text = VariableDimensions
        RichTextBoxVariable.LoadFile(LocOutput & OutFilename, RichTextBoxStreamType.PlainText)
    End Sub

    Public Function Read2DArrayFromFile(filename As String, delimiter As String) As Boolean
        'Reads the contents of a text file and assigns it to a 2d array
        Try
            Dim NumColumns As Integer
            Dim currentRow() As String = Nothing
            Dim RowCounter As Integer = 0
            Dim ColumnCounter As Integer = 0
            Dim OrininalSize = 200
            Dim IncreaseSizeBy As Integer = 100
            Dim TmpRetVarReal(,) As Double = Nothing
            Using parser As New TextFieldParser(filename)
                parser.SetDelimiters(delimiter)
                While Not parser.EndOfData
                    'Read current line
                    currentRow = parser.ReadFields()
                    If RowCounter = 0 Then
                        NumColumns = UBound(currentRow) + 1
                        ReDim TmpRetVarReal(NumColumns - 1, OrininalSize)
                    End If
                    For ColumnCounter = 0 To NumColumns - 1
                        TmpRetVarReal(ColumnCounter, RowCounter) = CDbl(Trim(currentRow(ColumnCounter)))
                    Next
                    If RowCounter >= UBound(TmpRetVarReal, 2) Then
                        ReDim Preserve TmpRetVarReal(NumColumns - 1, RowCounter + IncreaseSizeBy)
                    End If
                    RowCounter = RowCounter + 1
                End While
            End Using
            'ReDim Preserve TmpRetVarReal(NumColumns - 1, RowCounter - 1) 'Remove any unused rows from array and take transpose of array
            ReDim RetVarDouble(RowCounter - 1, NumColumns - 1)
            For i = 0 To RowCounter - 1
                For j = 0 To NumColumns - 1
                    RetVarDouble(i, j) = TmpRetVarReal(j, i)
                Next
            Next
            RetNumRows = UBound(RetVarDouble, 1) + 1
            RetNumCols = UBound(RetVarDouble, 2) + 1
            Return True
        Catch
            Return False
        End Try

    End Function


    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn2.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        Dim OutFilename As String = "MyPlot1.jpg"
        myProcess.WaitForExit()
        myProcess.Close()

        'Display image in picturebox
        PictureBox1.ImageLocation = LocOutput & OutFilename

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn3.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

        'Display image as a new figure window

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn4.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

        'Display image as a new figure window

    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn5.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn6.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn7.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn8.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn9.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn10.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn11.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub


    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn12.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn13.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles Button13.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn14.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles Button14.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn15.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button15_Click(sender As Object, e As EventArgs) Handles Button15.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn16.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button16_Click(sender As Object, e As EventArgs) Handles Button16.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn17.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button17_Click(sender As Object, e As EventArgs) Handles Button17.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn18.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button18_Click(sender As Object, e As EventArgs) Handles Button18.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn19.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Button19_Click(sender As Object, e As EventArgs) Handles Button19.Click
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = LocExe & "Evaluate"
        ProcessProperties.Arguments = LocScript & "MyIn20.txt" 'command line arguments
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit()
        myProcess.Close()

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        RichTextBoxScriptExample1.LoadFile(LocScript & "MyIn1.txt", RichTextBoxStreamType.PlainText)
        RichTextBox1.LoadFile(LocScript & "MyIn2.txt", RichTextBoxStreamType.PlainText)
        RichTextBox3.LoadFile(LocScript & "MyIn3.txt", RichTextBoxStreamType.PlainText)
        RichTextBox4.LoadFile(LocScript & "MyIn4.txt", RichTextBoxStreamType.PlainText)
        RichTextBox5.LoadFile(LocScript & "MyIn5.txt", RichTextBoxStreamType.PlainText)
        RichTextBox6.LoadFile(LocScript & "MyIn6.txt", RichTextBoxStreamType.PlainText)
        RichTextBox7.LoadFile(LocScript & "MyIn7.txt", RichTextBoxStreamType.PlainText)
        RichTextBox8.LoadFile(LocScript & "MyIn8.txt", RichTextBoxStreamType.PlainText)
        RichTextBox9.LoadFile(LocScript & "MyIn9.txt", RichTextBoxStreamType.PlainText)
        RichTextBox10.LoadFile(LocScript & "MyIn10.txt", RichTextBoxStreamType.PlainText)
        RichTextBox11.LoadFile(LocScript & "MyIn11.txt", RichTextBoxStreamType.PlainText)
        RichTextBox12.LoadFile(LocScript & "MyIn12.txt", RichTextBoxStreamType.PlainText)
        RichTextBox13.LoadFile(LocScript & "MyIn13.txt", RichTextBoxStreamType.PlainText)
        RichTextBox14.LoadFile(LocScript & "MyIn14.txt", RichTextBoxStreamType.PlainText)
        RichTextBox15.LoadFile(LocScript & "MyIn15.txt", RichTextBoxStreamType.PlainText)
        RichTextBox16.LoadFile(LocScript & "MyIn16.txt", RichTextBoxStreamType.PlainText)
        RichTextBox17.LoadFile(LocScript & "MyIn17.txt", RichTextBoxStreamType.PlainText)
        RichTextBox18.LoadFile(LocScript & "MyIn18.txt", RichTextBoxStreamType.PlainText)
        RichTextBox19.LoadFile(LocScript & "MyIn19.txt", RichTextBoxStreamType.PlainText)
        RichTextBox20.LoadFile(LocScript & "MyIn20.txt", RichTextBoxStreamType.PlainText)

        'Make all script combo boxes the same size and also the same locations. Do the same for the Execute buttons.
        Dim TemplateWidth As Integer = RichTextBoxScriptExample1.Size.Width
        Dim TemplateHeight As Integer = RichTextBoxScriptExample1.Size.Height
        Dim TemplateLocation As New System.Drawing.Point(RichTextBoxScriptExample1.Location.X, RichTextBoxScriptExample1.Location.Y)
        Dim TemplateLabelWidth As Integer = Label1.Size.Width
        Dim TemplateLabelHeight As Integer = Label1.Size.Height
        Dim TemplateLabelLocation As New System.Drawing.Point(Label1.Location.X, Label1.Location.Y)
        Dim TemplateExecuteWidth As Integer = ButtonRun.Size.Width
        Dim TemplateExecuteHeight As Integer = ButtonRun.Size.Height
        Dim TemplateExecuteLocation As New System.Drawing.Point(ButtonRun.Location.X, ButtonRun.Location.Y)
        '**************
        RichTextBox1.Width = TemplateWidth
        RichTextBox1.Height = TemplateHeight
        RichTextBox1.Location = TemplateLocation
        Label2.Width = TemplateLabelWidth
        Label2.Height = TemplateLabelHeight
        Label2.Location = TemplateLabelLocation
        Button1.Width = TemplateExecuteWidth
        Button1.Height = TemplateExecuteHeight
        Button1.Location = TemplateExecuteLocation
        '**************
        RichTextBox3.Width = TemplateWidth
        RichTextBox3.Height = TemplateHeight
        RichTextBox3.Location = TemplateLocation
        Label4.Width = TemplateLabelWidth
        Label4.Height = TemplateLabelHeight
        Label4.Location = TemplateLabelLocation
        Button2.Width = TemplateExecuteWidth
        Button2.Height = TemplateExecuteHeight
        Button2.Location = TemplateExecuteLocation
        '**************
        RichTextBox4.Width = TemplateWidth
        RichTextBox4.Height = TemplateHeight
        RichTextBox4.Location = TemplateLocation
        Label5.Width = TemplateLabelWidth
        Label5.Height = TemplateLabelHeight
        Label5.Location = TemplateLabelLocation
        Button3.Width = TemplateExecuteWidth
        Button3.Height = TemplateExecuteHeight
        Button3.Location = TemplateExecuteLocation
        '**************
        RichTextBox5.Width = TemplateWidth
        RichTextBox5.Height = TemplateHeight
        RichTextBox5.Location = TemplateLocation
        Label6.Width = TemplateLabelWidth
        Label6.Height = TemplateLabelHeight
        Label6.Location = TemplateLabelLocation
        Button4.Width = TemplateExecuteWidth
        Button4.Height = TemplateExecuteHeight
        Button4.Location = TemplateExecuteLocation
        '**************
        RichTextBox6.Width = TemplateWidth
        RichTextBox6.Height = TemplateHeight
        RichTextBox6.Location = TemplateLocation
        Label7.Width = TemplateLabelWidth
        Label7.Height = TemplateLabelHeight
        Label7.Location = TemplateLabelLocation
        Button5.Width = TemplateExecuteWidth
        Button5.Height = TemplateExecuteHeight
        Button5.Location = TemplateExecuteLocation
        '**************
        RichTextBox7.Width = TemplateWidth
        RichTextBox7.Height = TemplateHeight
        RichTextBox7.Location = TemplateLocation
        Label8.Width = TemplateLabelWidth
        Label8.Height = TemplateLabelHeight
        Label8.Location = TemplateLabelLocation
        Button6.Width = TemplateExecuteWidth
        Button6.Height = TemplateExecuteHeight
        Button6.Location = TemplateExecuteLocation
        '**************
        RichTextBox8.Width = TemplateWidth
        RichTextBox8.Height = TemplateHeight
        RichTextBox8.Location = TemplateLocation
        Label9.Width = TemplateLabelWidth
        Label9.Height = TemplateLabelHeight
        Label9.Location = TemplateLabelLocation
        Button7.Width = TemplateExecuteWidth
        Button7.Height = TemplateExecuteHeight
        Button7.Location = TemplateExecuteLocation
        '**************
        RichTextBox9.Width = TemplateWidth
        RichTextBox9.Height = TemplateHeight
        RichTextBox9.Location = TemplateLocation
        Label10.Width = TemplateLabelWidth
        Label10.Height = TemplateLabelHeight
        Label10.Location = TemplateLabelLocation
        Button8.Width = TemplateExecuteWidth
        Button8.Height = TemplateExecuteHeight
        Button8.Location = TemplateExecuteLocation
        '**************
        RichTextBox10.Width = TemplateWidth
        RichTextBox10.Height = TemplateHeight
        RichTextBox10.Location = TemplateLocation
        Label11.Width = TemplateLabelWidth
        Label11.Height = TemplateLabelHeight
        Label11.Location = TemplateLabelLocation
        Button9.Width = TemplateExecuteWidth
        Button9.Height = TemplateExecuteHeight
        Button9.Location = TemplateExecuteLocation
        '**************
        RichTextBox11.Width = TemplateWidth
        RichTextBox11.Height = TemplateHeight
        RichTextBox11.Location = TemplateLocation
        Label12.Width = TemplateLabelWidth
        Label12.Height = TemplateLabelHeight
        Label12.Location = TemplateLabelLocation
        Button10.Width = TemplateExecuteWidth
        Button10.Height = TemplateExecuteHeight
        Button10.Location = TemplateExecuteLocation
        '**************
        RichTextBox12.Width = TemplateWidth
        RichTextBox12.Height = TemplateHeight
        RichTextBox12.Location = TemplateLocation
        Label13.Width = TemplateLabelWidth
        Label13.Height = TemplateLabelHeight
        Label13.Location = TemplateLabelLocation
        Button11.Width = TemplateExecuteWidth
        Button11.Height = TemplateExecuteHeight
        Button11.Location = TemplateExecuteLocation
        '**************
        RichTextBox13.Width = TemplateWidth
        RichTextBox13.Height = TemplateHeight
        RichTextBox13.Location = TemplateLocation
        Label14.Width = TemplateLabelWidth
        Label14.Height = TemplateLabelHeight
        Label14.Location = TemplateLabelLocation
        Button12.Width = TemplateExecuteWidth
        Button12.Height = TemplateExecuteHeight
        Button12.Location = TemplateExecuteLocation
        '**************
        RichTextBox14.Width = TemplateWidth
        RichTextBox14.Height = TemplateHeight
        RichTextBox14.Location = TemplateLocation
        Label15.Width = TemplateLabelWidth
        Label15.Height = TemplateLabelHeight
        Label15.Location = TemplateLabelLocation
        Button13.Width = TemplateExecuteWidth
        Button13.Height = TemplateExecuteHeight
        Button13.Location = TemplateExecuteLocation
        '**************
        RichTextBox15.Width = TemplateWidth
        RichTextBox15.Height = TemplateHeight
        RichTextBox15.Location = TemplateLocation
        Label16.Width = TemplateLabelWidth
        Label16.Height = TemplateLabelHeight
        Label16.Location = TemplateLabelLocation
        Button14.Width = TemplateExecuteWidth
        Button14.Height = TemplateExecuteHeight
        Button14.Location = TemplateExecuteLocation
        '**************
        RichTextBox16.Width = TemplateWidth
        RichTextBox16.Height = TemplateHeight
        RichTextBox16.Location = TemplateLocation
        Label17.Width = TemplateLabelWidth
        Label17.Height = TemplateLabelHeight
        Label17.Location = TemplateLabelLocation
        Button15.Width = TemplateExecuteWidth
        Button15.Height = TemplateExecuteHeight
        Button15.Location = TemplateExecuteLocation
        '**************
        RichTextBox17.Width = TemplateWidth
        RichTextBox17.Height = TemplateHeight
        RichTextBox17.Location = TemplateLocation
        Label18.Width = TemplateLabelWidth
        Label18.Height = TemplateLabelHeight
        Label18.Location = TemplateLabelLocation
        Button16.Width = TemplateExecuteWidth
        Button16.Height = TemplateExecuteHeight
        Button16.Location = TemplateExecuteLocation
        '**************
        RichTextBox18.Width = TemplateWidth
        RichTextBox18.Height = TemplateHeight
        RichTextBox18.Location = TemplateLocation
        Label19.Width = TemplateLabelWidth
        Label19.Height = TemplateLabelHeight
        Label19.Location = TemplateLabelLocation
        Button17.Width = TemplateExecuteWidth
        Button17.Height = TemplateExecuteHeight
        Button17.Location = TemplateExecuteLocation
        '**************
        RichTextBox19.Width = TemplateWidth
        RichTextBox19.Height = TemplateHeight
        RichTextBox19.Location = TemplateLocation
        Label20.Width = TemplateLabelWidth
        Label20.Height = TemplateLabelHeight
        Label20.Location = TemplateLabelLocation
        Button18.Width = TemplateExecuteWidth
        Button18.Height = TemplateExecuteHeight
        Button18.Location = TemplateExecuteLocation
        '**************
        RichTextBox20.Width = TemplateWidth
        RichTextBox20.Height = TemplateHeight
        RichTextBox20.Location = TemplateLocation
        Label21.Width = TemplateLabelWidth
        Label21.Height = TemplateLabelHeight
        Label21.Location = TemplateLabelLocation
        Button19.Width = TemplateExecuteWidth
        Button19.Height = TemplateExecuteHeight
        Button19.Location = TemplateExecuteLocation
        '**************

    End Sub

End Class
